ACM学习历程—HDU 3092 Least common multiple(数论 && 动态规划 && 大数)

hihoCoder挑战赛12

Description

Partychen like to do mathematical problems. One day, when he was doing on a least common multiple(LCM) problem, he suddenly thought of a very interesting question: if given a number of S, and we divided S into some numbers , then what is the largest LCM of these numbers? partychen thought this problems for a long time but with no result, so he turned to you for help! 
Since the answer can very big,you should give the answer modulo M.

Input

There are many groups of test case.On each
test case only two integers S( 0 < S <= 3000) and M( 2<=M<=10000)
as mentioned above.

Output

Output the largest LCM modulo M of given S.

Sample Input

6 23

Sample Output

6

Hint: you can divied 6 as 1+2+3 and the
LCM(1,2,3)=6 is the largest so we output 6%23=6.

题目大意是,将一个数拆成若干数的和,然后对这些若干数求最小公倍数。求最小公倍数的最大值。

首先假设对于一个数x,我已经拆成若干数了。

对于其中两个数a和b。如果这两个数有最大公约数k。

那么这两个数个最小公倍数为a*b/k。

但是如果是a和b/k,最小公倍数依旧为a*b/k。但是两数的和更小了。这样我就可以多加一个数b-b/k,可能会使最终结果更大。

所以得到的第一个结论是,我尽量保证两两数都是互素的。

接下来,我要证明,每个数都应该是p^t的形式,p为素数。

因为当a > 1 &&
b > 1时,

(a-1)(b-1) >= 1。

即ab >= a+b。

同理来两次得到abc >= ab+c
>= a+b+c

所以,如果一个数y = p^t1*q^t2*c。p和q均为素数,且(p, q) =
(p, c) = (q, c) = 1。

那么我把拆成p^t1和q^t2和c,这三个数的最小公倍数就是y。但是这三个数的和更小了,可以再加入一个数y-p^t-q^t-c,可能会使结果更大。

所以,最终结论x = 2^c1 + 3^c2 +
5^c3 + ...,ci为素数。

到这里做法就比较多了。

有一种做法是用直接用dfs暴力搜索。

枚举对于一个素数p,加上p^i。

dfs(int now, int sum, BigInteger val)

这里now表示枚举到第几个素数,sum表示当前情况的和是多少,val表示当前最小公倍数。

这样一开始传入s,到了第二层递归树,分别为0, 2, 4,
8…,

对于2下方的一层是2, 2+3, 2+9…

首先3000以内素数有430个左右。层数可能会达到430层,就算不是满枝,复杂度也很大。

既然这样,

于是考虑p[i]数组表示i拆分的最小公倍数的最大值。

那么p[i] = max(p[i-prime[k]^t] * prime[k]^t)。

就是对于i,枚举它由i-prime[k]^t加prime[k]^t构成。然后求最值,这样之前枚举过的素数得到的最值都被记忆化了。

复杂度是:s*primeNum*log(s) ->
总和s*素数个数*枚举次方数

最差情况:3000*430*log(3000)这个复杂度不是很大,所以直接用java大数,这题也能过,不过网上也有取对数来防止数据溢出的方法。

代码:

import java.math.BigInteger;
import java.util.Scanner;

public class Main
{
    boolean isprime[] = new boolean[3005];
    int prime[] = new int[450];
    int top;
    BigInteger p[] = new BigInteger[3005];
    boolean vis[] = new boolean[3005];
    //埃氏筛法求素数
    void isPrime()
    {
        for (int i = 0; i < 3005; ++i)
            isprime[i] = true;
        isprime[0] = isprime[1] = false;//初始化
        for (int i = 2; i <= 3000; ++i)//筛法
        {
            if (isprime[i])
            {
                for (int j = i*i; j <= 3000; j += i)//上界太大可能会爆int
                {
                    isprime[j] = false;
                }
            }
        }
        top = 0;
        for (int i = 0; i <= 3000; ++i)
            if (isprime[i])
                prime[top++] = i;
    }

    BigInteger dp(int s)
    {
        BigInteger ans = new BigInteger("1");
        vis[0] = true;
        for (int i = 1; i <= s; ++i)
            vis[i] = false;
        p[0] = new BigInteger("1");
        for (int i = 0; i < top && prime[i] <= s; ++i)
        {
            for (int j = s; j >= prime[i]; --j)
            {
                for (int k = prime[i]; k <= j; k *= prime[i])
                {
                    if (j-k < 0 || !vis[j-k])
                        continue;
                    if (!vis[j])
                    {
                        p[j] = p[j-k].multiply(new BigInteger(Integer.toString(k)));
                        vis[j] = true;
                    }
                    else
                        p[j] = p[j].max(p[j-k].multiply(new BigInteger(Integer.toString(k))));
                }
            }
        }
        for (int i = 1; i <= s; ++i)
            if (vis[i])
                ans = ans.max(p[i]);
        return ans;
    }

    public static void main(String args[])
    {
        Main qt = new Main();
        qt.isPrime();
        BigInteger ans;
        int s, m;
        Scanner input = new Scanner(System.in);
        while (input.hasNext())
        {
            s = input.nextInt();
            m = input.nextInt();
            ans = qt.dp(s);
            System.out.println(ans.mod(new BigInteger(Integer.toString(m))));
        }
    }
}
时间: 2024-12-14 18:46:43

ACM学习历程—HDU 3092 Least common multiple(数论 && 动态规划 && 大数)的相关文章

ACM学习历程—HDU 4726 Kia&#39;s Calculation( 贪心&amp;&amp;计数排序)

DescriptionDoctor Ghee is teaching Kia how to calculate the sum of two integers. But Kia is so careless and alway forget to carry a number when the sum of two digits exceeds 9. For example, when she calculates 4567+5789, she will get 9246, and for 12

ACM学习历程—HDU 5023 A Corrupt Mayor&#39;s Performance Art(广州赛区网赛)(线段树)

Problem Description Corrupt governors always find ways to get dirty money. Paint something, then sell the worthless painting at a high price to someone who wants to bribe him/her on an auction, this seemed a safe way for mayor X to make money. Becaus

ACM学习历程—HDU5407 CRB and Candies(数论)

Problem Description CRB has N different candies. He is going to eat K candies.He wonders how many combinations he can select.Can you answer his question for all K (0 ≤ K ≤ N )?CRB is too hungry to check all of your answers one by one, so he only asks

ACM学习历程—HDU 3915 Game(Nim博弈 &amp;&amp; xor高斯消元)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3915 题目大意是给了n个堆,然后去掉一些堆,使得先手变成必败局势. 首先这是个Nim博弈,必败局势是所有xor和为0. 那么自然变成了n个数里面取出一些数,使得xor和为0,求取法数. 首先由xor高斯消元得到一组向量基,但是这些向量基是无法表示0的. 所以要表示0,必须有若干0来表示,所以n-row就是消元结束后0的个数,那么2^(n-row)就是能组成0的种数. 对n==row特判一下. 代码:

ACM学习历程—HDU 5534 Partial Tree(动态规划)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5534 题目大意是给了n个结点,让后让构成一个树,假设每个节点的度为r1, r2, ...rn,求f(x1)+f(x2)+...+f(xn)的最大值. 首先由于是树,所以有n-1条边,然后每条边连接两个节点,所以总的度数应该为2(n-1). 此外每个结点至少应该有一个度. 所以r1+r2+...rn = 2n-2.ri >= 1; 首先想到让ri >= 1这个条件消失: 令xi = ri,则x1+x

ACM学习历程—HDU 5536 Chip Factory(xor &amp;&amp; 字典树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5536 题目大意是给了一个序列,求(si+sj)^sk的最大值. 首先n有1000,暴力理论上是不行的. 此外题目中说大数据只有10组,小数据最多n只有100.(那么c*n^2的复杂度应该差不多) 于是可以考虑枚举i和j,然后匹配k. 于是可以先把所有s[k]全部存进一个字典树, 然后枚举s[i]和s[j],由于i.j.k互不相等,于是先从字典树里面删掉s[i]和s[j],然后对s[i]+s[j]这个

ACM学习历程—HDU 3949 XOR(xor高斯消元)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3949 题目大意是给n个数,然后随便取几个数求xor和,求第k小的.(重复不计算) 首先想把所有xor的值都求出来,对于这个规模的n是不可行的. 然后之前有过类似的题,求最大的,有一种方法用到了线性基. 那么线性基能不能表示第k大的呢? 显然,因为线性基可以不重复的表示所有结果.它和原数组是等价的. 对于一个满秩矩阵 100000 010000 001000 000100 000010 000001

背包系列练习( hdu 2844 Coins &amp;&amp; hdu 2159 &amp;&amp; poj 1170 Shopping Offers &amp;&amp; hdu 3092 Least common multiple &amp;&amp; poj 1015 Jury Compromise)

作为一个oier,以及大学acm党背包是必不可少的一部分.好久没做背包类动规了.久违地练习下-.- dd__engi的背包九讲:http://love-oriented.com/pack/ 鸣谢http://blog.csdn.net/eagle_or_snail/article/details/50987044,这里有大部分比较有趣的dp练手题. hdu 2844 Coins 多重背包 就是一个10w的多重背包,每个物品的cost同时也作为value去做背包,我们求的是每个容量下的价值,所以没

ACM学习历程—HDU 5012 Dice(ACM西安网赛)(bfs)

Problem Description There are 2 special dices on the table. On each face of the dice, a distinct number was written. Consider a1.a2,a3,a4,a5,a6 to be numbers written on top face, bottom face, left face, right face, front face and back face of dice A.